/*
 * wlanmodel/nodeinfo.h
 *
 * Copyright (C) 2008-2009 Reto Gantenbein
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __NODEINFO_H
#define __NODEINFO_H

#include <omnetpp.h>
#include <string>
#include <netinet/in.h>
#include <MACAddress.h>
#include "typedef.h"

/** Class containing all information of wireless node in the network */
class NodeInfo : public cObject
{
    public:
        NodeInfo();
        NodeInfo(const host_id *id, \
                const std::string name, \
                const in_addr *addr, \
                const uint16_t port);
        ~NodeInfo();

        std::string getHostId();
        std::string getHostName();
        void setInfo(NodeInfo &info);
        static void convertToHostIdString(const host_id *hostId, \
            std::string *hostIdString);
        void getNodeAddr(sockaddr_in *node_addr);
        int getProxyGate();
        std::string str();

    protected:
        std::string hostId;
        std::string hostName;
        MACAddress virtMacAddr;
        in_addr hostIp;
        uint16_t hostPort;
        int proxyHostGate;
        static int gateIndex;
};

#endif
